$   !   DRAWTREE.COM    Draws a directory tree on a VT100
$ On Control_Y Then $ exit
$ Set Noon
$ root = P1
$ Goto PAST_PROMPT
$PROMPT_DIRECTORY:
$!Inquire root "Root Directory"
$ If p1 .eqs. "" Then Root = F$Trnlnm("SYS$LOGIN")
$PAST_PROMPT:
$ If root .Eqs. "" Then Goto PROMPT_DIRECTORY
$   !
$   !   test if the directory exists
$   ! 
$ parse_root = F$Parse(root+"*.*;*")
$ If parse_root .Eqs. "" Then Goto PROMPT_DIRECTORY
$ If F$Search(parse_root) .Eqs. "" Then Goto PROMPT_DIRECTORY
$   !
$   !   extract the disk and directory fields
$   !
$ disk = F$Parse(parse_root,,,"DEVICE")
$ dir_root = F$Parse(parse_root,,,"DIRECTORY")
$   !
$   !   test it is not a sub-directory
$   !   strip delimiters
$   !
$   !
$   ! If F$Locate(".",dir_root) .Nes. F$Length(dir_root) -
$   !    Then Goto PROMPT_DIRECTORY
$ dir_root = dir_root - "<" - "[" - ">" - "]"
$   !
$   !   set up the output file
$   !   test If output is terminal it is a VT100
$   !
$ output_file = p2
$ If output_file .Eqs. "" Then output_file = "SYS$OUTPUT"
$ output_device = F$Parse(output_file,"DEVICE")
$ Goto DEVICE_OK
$!If F$Getdvi(output_device,"DEVCLASS") .Nes. 66 Then Goto DEVICE_OK
$ If vt100 Then Goto DEVICE_OK
$ Write Sys$Output "This program requires a VT100 type terminal.
$ Exit$
$DEVICE_OK:
$ On Control_Y Then Goto ABORT
$ Open/Write output 'output_file'
$ Write output ")0" ! into graphics mode
$   !   initialize things
$   !
$ lower_chars = "abcdefghijklmnopqrstuvwxyz0123456789"
$ pad_chars   = "qqqqqqqqq"   ! graphic dash
$ line_0      = ""
$ level       = 1
$ entry_1     = dir_root
$ Goto CALL_PRE_CASE
$RETURN_PRE_CASE:
$ level_1_dir = dir_root
$ line_1      = "[1;4;7m''entry_1'[m"
$PUSH:
$   !
$   !   push down a level
$   !
$ old_level = level
$ level = level + 1
$ parsed_spec_'level' = F$Parse("*.DIR",disk,"<"+level_'old_level'_dir+">")
$ next_entry_'level' = F$Search(parsed_spec_'level',level)
$   ! If search fails no more levels
$   !
$ If next_entry_'level' .Nes. "" Then Goto MORE_LEVELS
$ Write output line_'old_level'
$ Goto POP
$MORE_LEVELS:
$   !
$   !   mark this as the first entry and not the last entry
$   !
$ last_'level' = 0
$ first_'level' = 1
$LIST_LOOP:
$   !
$   !   for each each sub-directory
$   !   test If this entry is the last in the list
$   !   make the entry the file name field
$   !   Capitalize and lower case entry name
$   !
$ entry_'level' = next_entry_'level'
$ next_entry_'level' = F$Search(parsed_spec_'level',level)
$ If next_entry_'level' .Eqs. "" Then last_'level' = 1
$ entry_'level' = F$Parse(entry_'level',,,"NAME")
$CALL_PRE_CASE:
$ entry_length = F$Length(entry_'level')
$ counter = 1
$CASE_LOOP:
$ If counter .Eqs. entry_length Then Goto END_CASE
$ index = F$Cvui(0,8,F$Extract(counter,1,entry_'level')) - 65
$ If index .Les. 0 Then index = index + 43
$ entry_'level'['counter',1] := "''F$Extract(index,1,lower_chars)'"
$ counter = counter + 1
$ Goto CASE_LOOP
$END_CASE:
$ If level .Eqs. 1 Then Goto RETURN_PRE_CASE
$   !
$   !   figure out the attaching character
$   !             | not first |   first
$   !   ----------+-----------+----------
$   !    not last | right "T" | down "T"
$   !   ----------+-----------+----------
$   !      last   | right "L" |   dash
$   !
$ end_pad = "t"
$ If first_'level' Then end_pad = "w"
$ If last_'level' Then end_pad = "m"
$ If (first_'level') .And. (last_'level') Then end_pad = "q"
$   !
$   !   append dashes, attach character and new entry to line
$   !
$ line_'level' = line_'old_level' + -
                  F$Extract(F$Length(entry_'old_level'),9,pad_chars) + -
                  end_pad + "[4;7m" + entry_'level' + "[m"
$   !
$   !   blank out the entry and may be add place vertical bar connector
$   !
$ entry_'old_level' = "         x"
$ If last_'level' Then entry_'old_level' = "          "
$   !
$   !   fix up the lower level output line
$   !
$ old_old_level = old_level - 1
$ line_'old_level' = line_'old_old_level' + entry_'old_level'
$   !
$   !   calculate the directory specIfication for the next level
$   !
$ level_'level'_dir = level_'old_level'_dir + "." + entry_'level'
$ Goto PUSH
$POP:
$   !
$   ! restore parameters
$   !
$ level = old_level
$ old_level = old_level - 1
$ old_old_level = old_level - 1
$ If level .Eqs. 1 Then Goto CLEAN_UP  ! initial level all done
$ first_'level' = 0                   ! mark end of first entry
$ entry_'old_level' = "         "     ! blank out the entry
$ line_'old_level' = line_'old_old_level' + entry_'old_level'
$ If last_'level' Then Goto POP       ! done with this level
$ Goto LIST_LOOP                      ! for each sub-directory loop 
$ABORT:
$ Write output "[m"
$CLEAN_UP:
$ Write output ""
$ Close output
$ Exit$
