$!Author  : Ram Samudrala
$!	    SVVAIKUN@owucomcn.bitnet .or. SVVAIKUN@cc.owu.edu
$!
$!Usage   : ls [-options] [?] [filename]
$!ls      : list directory
$!     -a : list all files including the dot files
$!     -f : list files with a marker to identify the types: 
$!          / - directory
$!	    * - executable
$!	    $ - command file
$!     -l : list files in the long format
$!     -r : list subdirectories encountered
$!     -s : list files with sizes in bytes
$!      ? : help
$!
$!Features: You can set the variable searchfile so that ls lists all versions
$!          of the file (default) or change it to "*.*", if you want a single 
$!	    listing of each file. 
$!	    Wildcard characters are allowed (following VMS directory syntax).
$!
$!Bugs    : The -r option will not list the directory in which the files are. 
$!	    If you specify a filename, it has to have the complete extension.
$!	    . and .. are not listed properly when -l and -s options are used.
$! 	    Other minor negligible glitches.
$!
$!
$ searchfile = "*.*;*"
$ listline = ""
$ filename = ""
$ total    = 0
$ count	   = 0
$!
$ if p1 .eqs. "" then goto no_option
$ if f$locate("-",p1) .eqs. f$length(p1) then goto assignsearch
$ if p2 .nes. "" then searchfile = p2
$ if p1 .eqs. "?" then goto help
$ p1 = f$extract((f$locate("-",p1) + 1), f$length(p1), p1)
$ if f$locate("R",p1) .nes. f$length(p1) 
$ then 
$ sfile = f$dir()
$ searchfile = f$extract(0,f$length(sfile)-1,sfile) + "...]" + searchfile
$ endif
$ if f$locate("L",p1) .nes. f$length(p1) then goto longformat
$ if f$locate("A",p1) .nes. f$length(p1) then goto a_option
$ if f$locate("S",p1) .nes. f$length(p1) then goto s_option
$ goto no_option
$ assignsearch:
$ searchfile = p1
$!
$ no_option:
$ trailer = ""
$ directory = f$search(searchfile,2)
$ if directory .eqs. "" then goto done
$ file = f$extract((f$locate("]",directory) + 1),f$length(directory),directory)
$ if f$extract(0,1,file) .eqs. "." .and. f$locate("A",p1) .eqs. -
  f$length(p1) then goto no_option
$ count = count + 1
$ file = f$extract(0,f$locate(";",file),file) 
$ if f$locate("F",p1) .nes. f$length(p1) then gosub f_option
$ if f$extract(f$locate(".", file)+1,4,file) .eqs. "DIR" then gosub assignfile
$ file = f$edit(file, "lowercase") + trailer
$ listline = f$string(listline + f$fao("!#(#AS)",1,19,file))
$ if count .eqs. 4 
$ then
$ write sys$output listline
$ count = 0
$ listline = ""
$ endif
$ if f$locate("*",searchfile) .eqs. f$length(searchfile) then goto done
$ goto no_option
$!
$ longformat:
$ if f$locate("A",p1) .nes. f$length(p1) then gosub al_option
$ loop1:
$ trailer = ""
$ file = f$search(searchfile,2)
$ if file .eqs. "" then goto donel
$ tempfile = f$extract(f$locate("]",file) + 1, f$length(file),file)
$ if (f$extract(0,1,tempfile) .eqs. ".") .and. (f$locate("A",p1) .eqs. -
  f$length(p1)) then goto loop1
$ file = f$extract(0,f$locate(";",file),file) 
$ if f$locate("F",p1) .nes. f$length(p1) then gosub f_option
$ prot = f$file_attributes(file,"pro")
$ sysprot = f$extract(f$locate("M",prot) + 1,f$locate(",",prot) - 1,prot)
$ ownprot = f$extract(f$locate("O",prot),10,prot)
$ ownprot = f$extract(f$locate("=",ownprot),f$length(ownprot),ownprot)
$ worprot = f$extract(f$locate("L",prot) + 1, f$locate(",",prot) - 1,prot)
$ worprot = f$extract(f$locate("=",worprot),f$length(worprot),worprot)
$ if f$extract(f$length(file)-3,4,file) .eqs. "DIR" 
$ then prot = "d"
$ else
$ prot = "-"
$ endif
$ if f$locate("R",ownprot) .nes. f$length(ownprot) 
$ then  prot = prot + "r" 
$ else prot = prot + "-" 
$ endif
$ if f$locate("W",ownprot) .nes. f$length(ownprot) 
$ then  prot = prot + "w" 
$ else prot = prot + "-" 
$ endif
$ if f$locate("E",ownprot) .nes. f$length(ownprot) 
$ then  prot = prot + "x"
$ else prot = prot + "-" 
$ endif
$ if f$locate("R",sysprot) .nes. f$length(sysprot) 
$ then  prot = prot + "r" 
$ else prot = prot + "-" 
$ endif
$ if f$locate("W",sysprot) .nes. f$length(sysprot) 
$ then  prot = prot + "w" 
$ else prot = prot + "-" 
$ endif
$ if f$locate("E",sysprot) .nes. f$length(sysprot) 
$ then  prot = prot + "x"
$ else prot = prot + "-" 
$ endif
$ if f$locate("R",worprot) .nes. f$length(worprot) 
$ then  prot = prot + "r" 
$ else prot = prot + "-" 
$ endif
$ if f$locate("W",worprot) .nes. f$length(worprot) 
$ then  prot = prot + "w" 
$ else prot = prot + "-" 
$ endif
$ if f$locate("E",worprot) .nes. f$length(worprot) 
$ then  prot = prot + "x"
$ else prot = prot + "-" 
$ endif
$!
$ created = f$file_attributes(file,"cdt")
$ month = f$extract(f$locate("-",created) + 1,f$locate("-",created)+3,created)
$ month = f$extract(0,1,month) + f$edit(f$extract(1,2,month),"lowercase")
$ date = f$extract(0,f$locate("-",created),created)
$ time = f$extract(f$locate(":",created) - 2,f$length(created),created)
$ time = f$extract(0,f$locate(":",time) + 3,time)
$ size = f$file_attributes(file,"alq") * 512
$ uic = f$file_attributes(file,"uic")
$ uic = f$edit(f$extract(1,f$length(uic) - 2, uic), "lowercase")
$ sizeb = size / 1024 
$ file = f$extract((f$locate("]",file) + 1),f$length(file),file)
$ if f$extract(0,1,prot) .eqs. "d" then gosub assignfile
$ file = f$edit(file,"lowercase")
$ total = total + sizeb
$ sizeb = f$string(sizeb)
$ if f$locate("S",p1) .nes. f$length(p1) then -
  filename =  f$fao("!#(#AS)",1,5,sizeb) 
$ filename = filename+prot+"  "+"1"+" "+uic+" "+f$fao("!#(#AS)",1,6, -
  f$string(size))+" "+month+" "+date+" "+time+" "+file+trailer
$ write sys$output filename
$ filename = ""
$ if f$locate("*",searchfile) .eqs. f$length(searchfile) then got donel
$ goto loop1
$!
$ s_option:
$ trailer = ""
$ file = f$search(searchfile,2)
$ if file .eqs. "" then goto dones
$ file = f$extract(0,f$locate(";",file),file)  
$ sizeb = f$file_attributes(file,"alq") / 2
$ if f$locate("F",p1) .nes. f$length(p1) then gosub f_option
$ file = f$extract((f$locate("]",file) + 1),f$length(file),file)
$ if f$extract(0,1,file) .eqs. "." .and. f$locate("A",p1) .eqs. -
  f$length(p1) then goto s_option
$ count = count + 1
$ if f$extract(f$locate(".", file)+1,4,file) .eqs. "DIR" then gosub assignfile
$ file = f$edit(file,"lowercase") + trailer
$ total = total + sizeb
$ sizeb = f$string(sizeb)
$ listline = f$string(listline + f$fao("!#(#AS)",1,4,sizeb) + -
  f$fao("!#(#AS)",1,15,file)) 
$ if count .eqs. 4 
$ then
$ write sys$output listline
$ count = 0
$ listline = ""
$ endif
$ if f$locate("*",searchfile) .eqs. f$length(searchfile) then goto dones
$ goto s_option
$ done:
$ if listline .nes. "" then write sys$output listline
$ exit
$ dones:
$ total = "total " + f$string(total)
$ if listline .nes. "" then write sys$output listline
$ if f$locate("S",p1) .nes. f$length(p1) then write sys$output total
$ exit
$ donel:
$ total = "total " + f$string(total)
$ write sys$output total
$ exit
$!
$ a_option:
$ count = 2
$ listline = f$fao("!#(#AS)",2,19,".","..")
$ if f$locate("S",p1) .nes. f$length(p1) then goto s_option
$ goto no_option
$!
$ al_option:
$ if f$locate("F",p1) .nes. f$length(p1) then trailer = "/"
$ write sys$output ".''trailer'"
$ write sys$output "..''trailer'"
$ return
$!
$ assignfile: 
$ file = f$extract(0,f$locate(".",file),file)
$ if f$locate("F",p1) .nes. f$length(p1) then trailer = "/"
$ return
$!
$ f_option:
$ if f$extract(f$length(file) - 3,4,file) .eqs. "COM" then trailer = "$"
$ if f$extract(f$length(file) - 3,4,file) .eqs. "EXE" then trailer = "*"
$ return
$!
$ help:
$ write sys$output "Usage: ls [-alfhrs] [?] [filename]"
$ exit
